#[doc = "Register `IMO_TRIM12` reader"]
pub struct R(crate::R<IMO_TRIM12_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<IMO_TRIM12_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<IMO_TRIM12_SPEC>> for R {
    fn from(reader: crate::R<IMO_TRIM12_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `IMO_TRIM12` writer"]
pub struct W(crate::W<IMO_TRIM12_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<IMO_TRIM12_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<IMO_TRIM12_SPEC>> for W {
    fn from(writer: crate::W<IMO_TRIM12_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `OFFSET` reader - Frequency trim bits. These bits are determined at manufacturing time for each FREQ setting (IMO_TRIM2) and stored in SFLASH."]
pub struct OFFSET_R(crate::FieldReader<u8, u8>);
impl OFFSET_R {
    pub(crate) fn new(bits: u8) -> Self {
        OFFSET_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for OFFSET_R {
    type Target = crate::FieldReader<u8, u8>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `OFFSET` writer - Frequency trim bits. These bits are determined at manufacturing time for each FREQ setting (IMO_TRIM2) and stored in SFLASH."]
pub struct OFFSET_W<'a> {
    w: &'a mut W,
}
impl<'a> OFFSET_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u8) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xff) | (value as u8 & 0xff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:7 - Frequency trim bits. These bits are determined at manufacturing time for each FREQ setting (IMO_TRIM2) and stored in SFLASH."]
    #[inline(always)]
    pub fn offset(&self) -> OFFSET_R {
        OFFSET_R::new((self.bits & 0xff) as u8)
    }
}
impl W {
    #[doc = "Bits 0:7 - Frequency trim bits. These bits are determined at manufacturing time for each FREQ setting (IMO_TRIM2) and stored in SFLASH."]
    #[inline(always)]
    pub fn offset(&mut self) -> OFFSET_W {
        OFFSET_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u8) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "IMO Trim Register (SRSSv2)\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [imo_trim12](index.html) module"]
pub struct IMO_TRIM12_SPEC;
impl crate::RegisterSpec for IMO_TRIM12_SPEC {
    type Ux = u8;
}
#[doc = "`read()` method returns [imo_trim12::R](R) reader structure"]
impl crate::Readable for IMO_TRIM12_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [imo_trim12::W](W) writer structure"]
impl crate::Writable for IMO_TRIM12_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets IMO_TRIM12 to value 0"]
impl crate::Resettable for IMO_TRIM12_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
